diff -u -r postgresql-7.0.2/src/interfaces/odbc/info.c postgresql-7.0.2.new/src/interfaces/odbc/info.c
--- postgresql-7.0.2/src/interfaces/odbc/info.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/info.c	Tue Jun 20 13:43:22 2000
@@ -2577,11 +2617,11 @@
 			stmt->errormsg = SC_create_errormsg(htbl_stmt);
 			stmt->errornumber = tbl_stmt->errornumber;
 			SC_log_error(func, "", stmt);
-			SQLFreeStmt(htbl_stmt, SQL_DROP);
+			PG__SQLFreeStmt(htbl_stmt, SQL_DROP);
 			return SQL_ERROR;
 		}
 
-		keyresult = SQLAllocStmt( stmt->hdbc, &hpkey_stmt);
+		keyresult = PG__SQLAllocStmt( stmt->hdbc, &hpkey_stmt);
 		if((keyresult != SQL_SUCCESS) && (keyresult != SQL_SUCCESS_WITH_INFO)) {
 			stmt->errornumber = STMT_NO_MEMORY_ERROR;
 			stmt->errormsg = "Couldn't allocate statement for SQLForeignKeys (pkeys) result.";
@@ -2589,22 +2629,22 @@
 			return SQL_ERROR;
 		}
 
-		keyresult = SQLPrimaryKeys(hpkey_stmt, NULL, 0, NULL, 0, pktab, SQL_NTS);
+		keyresult = PG__SQLPrimaryKeys(hpkey_stmt, NULL, 0, NULL, 0, pktab, SQL_NTS);
 		if (keyresult != SQL_SUCCESS) {
 			stmt->errornumber = STMT_NO_MEMORY_ERROR;
 			stmt->errormsg = "Couldn't get primary keys for SQLForeignKeys result.";
 			SC_log_error(func, "", stmt);
-			SQLFreeStmt(hpkey_stmt, SQL_DROP);
+			PG__SQLFreeStmt(hpkey_stmt, SQL_DROP);
 			return SQL_ERROR;
 		}
 
-		keyresult = SQLBindCol(hpkey_stmt, 4, SQL_C_CHAR,
+		keyresult = PG__SQLBindCol(hpkey_stmt, 4, SQL_C_CHAR,
 								pkey, sizeof(pkey), NULL);
 		if (keyresult != SQL_SUCCESS) {
 			stmt->errornumber = STMT_NO_MEMORY_ERROR;
 			stmt->errormsg = "Couldn't bindcol for primary keys for SQLForeignKeys result.";
 			SC_log_error(func, "", stmt);
-			SQLFreeStmt(hpkey_stmt, SQL_DROP);
+			PG__SQLFreeStmt(hpkey_stmt, SQL_DROP);
 			return SQL_ERROR;
 		}
 
@@ -2639,7 +2679,7 @@
 			pkey_ptr = ptr;
 
 
-			keyresult = SQLExtendedFetch(hpkey_stmt, SQL_FETCH_FIRST, -1, NULL, NULL);
+			keyresult = PG__SQLExtendedFetch(hpkey_stmt, SQL_FETCH_FIRST, -1, NULL, NULL);
 			if ( keyresult != SQL_SUCCESS || strcmp(pkey, ptr)) {
 				ntabs = 0;
 			}
@@ -2654,7 +2694,7 @@
 				}
 				ptr += strlen(ptr) + 1;
 
-				keyresult = SQLExtendedFetch(hpkey_stmt, SQL_FETCH_NEXT, -1, NULL, NULL);
+				keyresult = PG__SQLExtendedFetch(hpkey_stmt, SQL_FETCH_NEXT, -1, NULL, NULL);
 			}
 				
 			mylog("Foreign Key Case#1: nargs = %d, ntabs = %d, pkeys = %d\n", nargs, ntabs, pkeys);
@@ -2712,24 +2752,53 @@
 
 			}
 
-			result = SQLFetch(htbl_stmt);
+			result = PG__SQLFetch(htbl_stmt);
 		}
     }
 	else {
 		stmt->errormsg = "No tables specified to SQLForeignKeys.";
 		stmt->errornumber = STMT_INTERNAL_ERROR;
 		SC_log_error(func, "", stmt);
-		SQLFreeStmt(htbl_stmt, SQL_DROP);
+		PG__SQLFreeStmt(htbl_stmt, SQL_DROP);
 		return SQL_ERROR;
 	}
 
-	SQLFreeStmt(htbl_stmt, SQL_DROP);
-	SQLFreeStmt(hpkey_stmt, SQL_DROP);
+	PG__SQLFreeStmt(htbl_stmt, SQL_DROP);
+	PG__SQLFreeStmt(hpkey_stmt, SQL_DROP);
 
 	mylog("SQLForeignKeys(): EXIT, stmt=%u\n", stmt);
     return SQL_SUCCESS;
 }
 
+RETCODE SQL_API SQLForeignKeys(
+                               HSTMT         hstmt,
+                               UCHAR FAR *   szPkTableQualifier,
+                               SWORD         cbPkTableQualifier,
+                               UCHAR FAR *   szPkTableOwner,
+                               SWORD         cbPkTableOwner,
+                               UCHAR FAR *   szPkTableName,
+                               SWORD         cbPkTableName,
+                               UCHAR FAR *   szFkTableQualifier,
+                               SWORD         cbFkTableQualifier,
+                               UCHAR FAR *   szFkTableOwner,
+                               SWORD         cbFkTableOwner,
+                               UCHAR FAR *   szFkTableName,
+                               SWORD         cbFkTableName)
+{
+    return PG__SQLForeignKeys( hstmt,
+            szPkTableQualifier,
+            cbPkTableQualifier,
+            szPkTableOwner,
+            cbPkTableOwner,
+            szPkTableName,
+            cbPkTableName,
+            szFkTableQualifier,
+            cbFkTableQualifier,
+            szFkTableOwner,
+            cbFkTableOwner,
+            szFkTableName,
+            cbFkTableName );
+}
 
 
 RETCODE SQL_API SQLProcedureColumns(
diff -u -r postgresql-7.0.2/src/interfaces/odbc/misc.h postgresql-7.0.2.new/src/interfaces/odbc/misc.h
--- postgresql-7.0.2/src/interfaces/odbc/misc.h	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/misc.h	Tue Jun 20 13:43:24 2000
@@ -16,8 +16,10 @@
 
 #ifndef WIN32
 #include "gpps.h"
+#ifndef HAVE_SQLGETPRIVATEPROFILESTRING
 #define SQLGetPrivateProfileString(a,b,c,d,e,f) GetPrivateProfileString(a,b,c,d,e,f)
 #endif
+#endif
 
 #include <stdio.h>
 
@@ -90,4 +92,114 @@
 
 int my_strcpy(char *dst, int dst_len, char *src, int src_len);
 
+
+/*
+ * prototypes for the internal versions of ODBC functions. 
+ * We need to do this because when used under a unix driver manager the DM exports
+ * the same function entry points, so the application calls SQLExecDirect in the DM
+ * the DM calls SQLExecDirect in the driver, which then calls SQLPrepare, this 
+ * however calls SQLPrepare in the DM not the driver. Prefixing all the calls used
+ * internally by PG__ fixes this problem. Both unixODBC and iODBC will show this
+ * problem
+ */
+
+#ifndef WIN32
+#include "iodbc.h"
+#include "isqlext.h"
+#else
+#include <windows.h>
+#include <sqlext.h>
+#endif
+
+RETCODE SQL_API PG__SQLExecDirect(
+        HSTMT     hstmt,
+        UCHAR FAR *szSqlStr,
+        SDWORD    cbSqlStr);
+
+RETCODE SQL_API PG__SQLAllocStmt(HDBC      hdbc,
+	    HSTMT FAR *phstmt);
+
+RETCODE SQL_API PG__SQLExecute(
+        HSTMT   hstmt);
+
+RETCODE SQL_API PG__SQLTransact(
+        HENV    henv,
+        HDBC    hdbc,
+        UWORD   fType);
+
+RETCODE SQL_API PG__SQLFreeStmt(HSTMT     hstmt,
+	    UWORD     fOption);
+
+RETCODE SQL_API PG__SQLBindParameter(
+        HSTMT      hstmt,
+        UWORD      ipar,
+        SWORD      fParamType,
+        SWORD      fCType,
+        SWORD      fSqlType,
+        UDWORD     cbColDef,
+        SWORD      ibScale,
+        PTR        rgbValue,
+        SDWORD     cbValueMax,
+        SDWORD FAR *pcbValue);
+
+RETCODE SQL_API PG__SQLBindCol(
+        HSTMT      hstmt,
+        UWORD      icol,
+        SWORD      fCType,
+        PTR        rgbValue,
+        SDWORD     cbValueMax,
+        SDWORD FAR *pcbValue);
+
+RETCODE SQL_API PG__SQLColumns(
+        HSTMT        hstmt,
+        UCHAR FAR *  szTableQualifier,
+        SWORD        cbTableQualifier,
+        UCHAR FAR *  szTableOwner,
+        SWORD        cbTableOwner,
+        UCHAR FAR *  szTableName,
+        SWORD        cbTableName,
+        UCHAR FAR *  szColumnName,
+        SWORD        cbColumnName);
+
+RETCODE SQL_API PG__SQLFetch(
+        HSTMT   hstmt);
+
+RETCODE SQL_API PG__SQLGetData(
+        HSTMT      hstmt,
+        UWORD      icol,
+        SWORD      fCType,
+        PTR        rgbValue,
+        SDWORD     cbValueMax,
+        SDWORD FAR *pcbValue);
+
+RETCODE SQL_API PG__SQLPrimaryKeys(
+        HSTMT         hstmt,
+        UCHAR FAR *   szTableQualifier,
+        SWORD         cbTableQualifier,
+        UCHAR FAR *   szTableOwner,
+        SWORD         cbTableOwner,
+        UCHAR FAR *   szTableName,
+        SWORD         cbTableName);
+
+RETCODE SQL_API PG__SQLForeignKeys(
+        HSTMT         hstmt,
+        UCHAR FAR *   szPkTableQualifier,
+        SWORD         cbPkTableQualifier,
+        UCHAR FAR *   szPkTableOwner,
+        SWORD         cbPkTableOwner,
+        UCHAR FAR *   szPkTableName,
+        SWORD         cbPkTableName,
+        UCHAR FAR *   szFkTableQualifier,
+        SWORD         cbFkTableQualifier,
+        UCHAR FAR *   szFkTableOwner,
+        SWORD         cbFkTableOwner,
+        UCHAR FAR *   szFkTableName,
+        SWORD         cbFkTableName);
+
+RETCODE SQL_API PG__SQLExtendedFetch(
+        HSTMT      hstmt,
+        UWORD      fFetchType,
+        SDWORD     irow,
+        UDWORD FAR *pcrow,
+        UWORD  FAR *rgfRowStatus);
 #endif
diff -u -r postgresql-7.0.2/src/interfaces/odbc/parse.c postgresql-7.0.2.new/src/interfaces/odbc/parse.c
--- postgresql-7.0.2/src/interfaces/odbc/parse.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/parse.c	Tue Jun 20 13:43:22 2000
@@ -576,7 +576,7 @@
 
 			mylog("PARSE: Getting SQLColumns for table[%d]='%s'\n", i, ti[i]->name);
 
-			result = SQLAllocStmt( stmt->hdbc, &hcol_stmt);
+			result = PG__SQLAllocStmt( stmt->hdbc, &hcol_stmt);
 			if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO)) {
 				stmt->errormsg = "SQLAllocStmt failed in parse_statement for columns.";
 				stmt->errornumber = STMT_NO_MEMORY_ERROR;
@@ -587,7 +587,7 @@
 			col_stmt = (StatementClass *) hcol_stmt;
 			col_stmt->internal = TRUE;
 
-			result = SQLColumns(hcol_stmt, "", 0, "", 0, 
+			result = PG__SQLColumns(hcol_stmt, "", 0, "", 0, 
 						ti[i]->name, (SWORD) strlen(ti[i]->name), "", 0);
 		
 			mylog("        Past SQLColumns\n");
@@ -622,11 +622,11 @@
 
 				conn->ntables++;
 
-				SQLFreeStmt(hcol_stmt, SQL_DROP);
+				PG__SQLFreeStmt(hcol_stmt, SQL_DROP);
 				mylog("Created col_info table='%s', ntables=%d\n", ti[i]->name, conn->ntables);
 			}
 			else {
-				SQLFreeStmt(hcol_stmt, SQL_DROP);
+				PG__SQLFreeStmt(hcol_stmt, SQL_DROP);
 				break;
 			}
 		}
diff -u -r postgresql-7.0.2/src/interfaces/odbc/results.c postgresql-7.0.2.new/src/interfaces/odbc/results.c
--- postgresql-7.0.2/src/interfaces/odbc/results.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/results.c	Tue Jun 20 13:43:22 2000
@@ -595,7 +595,7 @@
 
 //      Returns result data for a single column in the current row.
 
-RETCODE SQL_API SQLGetData(
+RETCODE SQL_API PG__SQLGetData(
         HSTMT      hstmt,
         UWORD      icol,
         SWORD      fCType,
@@ -763,12 +763,26 @@
     }
 }
 
-
+RETCODE SQL_API SQLGetData(
+        HSTMT      hstmt,
+        UWORD      icol,
+        SWORD      fCType,
+        PTR        rgbValue,
+        SDWORD     cbValueMax,
+        SDWORD FAR *pcbValue)
+{
+    return PG__SQLGetData( hstmt,
+            icol,
+            fCType,
+            rgbValue,
+            cbValueMax,
+            pcbValue );
+}
 
 //      Returns data for bound columns in the current row ("hstmt->iCursor"),
 //      advances the cursor.
 
-RETCODE SQL_API SQLFetch(
+RETCODE SQL_API PG__SQLFetch(
         HSTMT   hstmt)
 {
 static char *func = "SQLFetch";
@@ -829,9 +843,15 @@
 	return SC_fetch(stmt);
 }
 
+RETCODE SQL_API SQLFetch(
+        HSTMT   hstmt)
+{
+    return PG__SQLFetch( hstmt );
+}
+
 //      This fetchs a block of data (rowset).
 
-RETCODE SQL_API SQLExtendedFetch(
+RETCODE SQL_API PG__SQLExtendedFetch(
         HSTMT      hstmt,
         UWORD      fFetchType,
         SDWORD     irow,
@@ -1097,6 +1117,20 @@
 	else
 		return SQL_SUCCESS;
 
+}
+
+RETCODE SQL_API SQLExtendedFetch(
+        HSTMT      hstmt,
+        UWORD      fFetchType,
+        SDWORD     irow,
+        UDWORD FAR *pcrow,
+        UWORD  FAR *rgfRowStatus)
+{
+    return PG__SQLExtendedFetch( hstmt,
+            fFetchType,
+            irow,
+            pcrow,
+            rgfRowStatus );
 }
 
 
diff -u -r postgresql-7.0.2/src/interfaces/odbc/statement.c postgresql-7.0.2.new/src/interfaces/odbc/statement.c
--- postgresql-7.0.2/src/interfaces/odbc/statement.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/statement.c	Tue Jun 20 13:43:22 2000
@@ -61,7 +61,7 @@
 };
 
 
-RETCODE SQL_API SQLAllocStmt(HDBC      hdbc,
+RETCODE SQL_API PG__SQLAllocStmt(HDBC      hdbc,
 			     HSTMT FAR *phstmt)
 {
 static char *func="SQLAllocStmt";
@@ -109,8 +109,14 @@
     return SQL_SUCCESS;
 }
 
+RETCODE SQL_API SQLAllocStmt(HDBC      hdbc,
+			     HSTMT FAR *phstmt)
+{
+    return PG__SQLAllocStmt( hdbc, phstmt );
+}
 
-RETCODE SQL_API SQLFreeStmt(HSTMT     hstmt,
+
+RETCODE SQL_API PG__SQLFreeStmt(HSTMT     hstmt,
 			    UWORD     fOption)
 {
 static char *func="SQLFreeStmt";
@@ -170,6 +176,11 @@
     return SQL_SUCCESS;
 }
 
+RETCODE SQL_API SQLFreeStmt(HSTMT     hstmt,
+			    UWORD     fOption)
+{
+    return PG__SQLFreeStmt( hstmt, fOption );
+}
 
 
 /**********************************************************************
@@ -479,7 +490,7 @@
 	if (self->status == STMT_READY) {
 		mylog("              preprocess: status = READY\n");
 
-		SQLExecute(self);
+		PG__SQLExecute(self);
 
 		if (self->status == STMT_FINISHED) {
 			mylog("              preprocess: after status = FINISHED, so set PREMATURE\n");
